﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Syncfusion.Windows.Tools.Controls
Imports Syncfusion.Windows.Shared

Namespace RichTextBoxAdvSample
	''' <summary>
    ''' Interaction logic for MainWindow.xaml
    ''' </summary>
    Partial Public Class MainWindow
        Inherits RibbonWindow
        Public Sub New()
            InitializeComponent()
#If Framework4_0 Then
            'Enables touch manipulation.
            rte.IsManipulationEnabled = True
#End If
            AddHandler rte.FileOpening, Function(sender, e) AnonymousMethod1(sender, e)

            AddHandler rte.FileSaving, Function(sender, e) AnonymousMethod2(sender, e)

            DataContext = rte

            SkinStorage.SetVisualStyle(Me, "Office2010Blue")
        End Sub

        Private Function AnonymousMethod1(ByVal sender As Object, ByVal e As Object) As Object
            rte.Document = DocxImporting.ConvertToDocumentAdv(e.DocumentStream, e.FormatType)
            Return Nothing
        End Function

        Private Function AnonymousMethod2(ByVal sender As Object, ByVal e As Object) As Object
            DocxExporting.ConvertToDocument(rte.Document, e.DoucmentStream, e.FormatType)
            Return Nothing
        End Function
    End Class

    Public Class ZoomFactorInPercentage
        Implements IValueConverter
        Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.Convert
            Dim factor As Double = Math.Round(System.Convert.ToDouble(value), 2)
            If factor = 0 Then
                factor = 0.1
            End If
            Return CInt(Fix(factor * 100 * 4))
        End Function

        Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As System.Globalization.CultureInfo) As Object Implements IValueConverter.ConvertBack
            Throw New NotImplementedException()
        End Function
    End Class

    Public Class RunAdv
        Inherits Run

        Public Sub New()

        End Sub

        Public Shared ReadOnly RunTextProperty As DependencyProperty = DependencyProperty.Register("RunText", GetType(String), GetType(RunAdv), New PropertyMetadata(String.Empty, AddressOf OnRunTextChanged))

        Public Property RunText As String
            Get
                Return CStr(GetValue(RunTextProperty))
            End Get
            Set(ByVal value As String)
                SetValue(RunTextProperty, value)
            End Set
        End Property

        Private Shared Sub OnRunTextChanged(ByVal obj As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
            Dim run As RunAdv = TryCast(obj, RunAdv)
            run.OnRunTextChanged(e)
        End Sub

        Private Sub OnRunTextChanged(ByVal e As DependencyPropertyChangedEventArgs)
            Text = TryCast(e.NewValue, String)
        End Sub
    End Class
End Namespace
